<?php

namespace Lc\ShopBundle\Form;

use CKSource\Bundle\CKFinderBundle\Form\Type\CKFinderFileChooserType;
use Doctrine\ORM\EntityManagerInterface;
use FOS\CKEditorBundle\Form\Type\CKEditorType;
use Lc\ShopBundle\Context\ProductFamilyInterface;
use Lc\ShopBundle\Context\ProductInterface;
use Lc\ShopBundle\Context\TaxRateInterface;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;
use function PHPSTORM_META\type;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ProductType extends AbstractType
{
        protected $em;

        public function __construct(EntityManagerInterface $entityManager)
        {
                $this->em = $entityManager;
        }
        public function buildForm(FormBuilderInterface $builder, array $options)
        {

                $builder->add('titleInherited', CheckboxType::class, array(
                        'mapped'=>false,
                        'required'=>false
                ));

                $builder->add('title', TextType::class, array(
                        "required" => false
                )) ;

                $builder->add('unitInherited', CheckboxType::class, array(
                        'mapped'=>false,
                        'required'=>false
                ));
                $builder->add('unit', ChoiceType::class, array(
                        'label' => 'Unité',
                        "required" => false,
                        'choices' => array(
                                'pièce' => 'piece',
                                'g' => 'g',
                                'kg' => 'kg',
                                'ml' => 'ml',
                                'L' => 'L'
                        ),
                ));

                $builder->add('weightInherited', CheckboxType::class, array(
                        'mapped'=>false,
                        'required'=>false
                ));
                $builder->add('weight', NumberType::class, array(
                        'label' => 'Poids',
                        "required" => false,
                        'attr' => [
                                'append_html' => 'g'
                        ]
                ));

                $builder->add('stepInherited', CheckboxType::class, array(
                        'mapped'=>false,
                        'required'=>false
                ));
                $builder->add('step', NumberType::class, array(
                        'label' => 'Pas',
                        "required" => false,
                        'help' => 'Quantité à incrémenter / décrémenter lors des mouvements de quantité',
                ));

                $builder->add('priceInherited', CheckboxType::class, array(
                        'mapped'=>false,
                        'required'=>false
                ));
                $builder->add('price', NumberType::class, array(
                        'label' => 'Prix',
                        "required" => false
                ));

                $builder->add('priceWithTax', NumberType::class, array(
                        'label' => 'Prix TTC',
                        'required' => false,
                        'mapped' => false
                ));

                $builder->add('availableQuantity', NumberType::class, array(
                        'label' => 'Quantité disponible',
                        'required' => false,
                ));

                $builder->add('position', HiddenType::class);

        }

        public function configureOptions(OptionsResolver $resolver)
        {
                $resolver->setDefaults([
                        'data_class' => $this->em->getClassMetadata(ProductInterface::class)->getName(),
                ]);
        }
}
