
let mixinPriceProduct = {
    data() {
        return {
            price: null,
            priceWithTax: null
        };
    },
    methods: {
        changePrice: function () {
            this.priceUpdate('price');
        },
        changePriceWithTax: function () {
            this.priceUpdate('priceWithTax');
        },
        priceUpdate: function (priceType) {
            if (priceType == 'priceWithTax' && this.price) {
                this.price = parseFloat(this.price.replace(',', '.')).toFixed(3);
                this.priceWithTax = getPriceWithTax(this.price, this.productFamily.taxRateValue );
            } else if (this.priceWithTax){
                this.priceWithTax = parseFloat(this.priceWithTax.replace(',', '.')).toFixed(2);
                this.price = getPrice(this.priceWithTax, this.productFamily.taxRateValue );
            }
        }
    }

};

let mixinPriceWithTaxField = {
    data() {
        return {
            price: null,
            priceWithTax: null,
            taxRate:null,
            taxRateValue:null
        };
    },
    mounted: function () {
        this.setTaxRateValue();
    },
    methods: {
        /*changeTaxRate: function () {
            this.$emit('tax-rate-change');
            this.changePriceWithTax();
        },*/
        changePrice: function () {
            this.priceUpdate('price');
        },
        changePriceWithTax: function () {
            this.priceUpdate('priceWithTax');
        },
        priceUpdate: function (priceType) {

            if (priceType == 'priceWithTax' && this.price) {
                this.price = parseFloat(this.price.replace(',', '.')).toFixed(3);
                this.priceWithTax = getPriceWithTax(this.price, this.taxRateValue );
            } else if (this.priceWithTax){
                this.priceWithTax = parseFloat(this.priceWithTax.replace(',', '.')).toFixed(2);
                this.price = getPrice(this.priceWithTax, this.taxRateValue );
            }
        },
        setTaxRateValue: function () {
            this.taxRateValue = $('#productfamily_taxRate').find('option:selected').data('tax-rate-value');
        }
    },
    watch:{
        taxRate: function (){
            this.setTaxRateValue();
            this.changePriceWithTax();
        }
    }

};


let mixinTemplate = {
    data() {
        return {
            templateRender: null,
        }
    },
    render(h) {
        if (!this.templateRender) {
            return h('div', 'loading...');
        } else { // If there is a template, I'll show it
            return this.templateRender();
        }
    },
    watch: {
        // Every time the template prop changes, I recompile it to update the DOM
        template: {
            immediate: true, // makes the watcher fire on first render, too.
            handler() {
                if (this.template) {
                    var res = Vue.compile(this.template);

                    this.templateRender = res.render;

                    // staticRenderFns belong into $options,
                    // appearantly
                    this.$options.staticRenderFns = []

                    // clean the cache of static elements
                    // this is a cache with the results from the staticRenderFns
                    this._staticTrees = []

                    // Fill it with the new staticRenderFns
                    for (var i in res.staticRenderFns) {
                        //staticRenderFns.push(res.staticRenderFns[i]);
                        this.$options.staticRenderFns.push(res.staticRenderFns[i])
                    }
                }
            }
        }
    }
}

