// Reference array sent to dynamic staticRenderFns
var staticRenderFns = [];


Vue.component('product-unit-price', {
    mixins: [mixinPriceWithTaxField, mixinTemplate],
    props: ['template', 'keyForm'],
    data() {
        return Object.assign(
            {
                step: null,
                unit: null,
                weight: null
            }, window.productUnitPriceValues);

    },

    methods: {
        getUnitReference: function () {
            if (this.unit == 'g') {
                return 'kg';
            } else if (this.unit == 'ml') {
                return 'L';
            } else {
                return this.unit;
            }
        }
    },
    mounted: function () {
        this.priceUpdate('priceWithTax');
    },
    watch: {

            /*log($('.product-form.modal .select-unit'));
            $('.product-form.modal .select-unit').find('option:selected').each(function(i,elm){
                $(this).prop("selected", false);
            });
            log($('.product-form.modal .select-unit'));*/

    }
});

Vue.component('product-form', {
    mixins: [mixinPriceProduct, mixinTemplate],
    props: ['template', 'keyForm', 'productFamily'],
    data() {
        return Object.assign(
            {
                title: null,
                titleInherited: null,
                fieldToUpdate: ['title', 'unit', 'weight', 'step', 'price'],
                unit: null,
                unitInherited: null,
                step: null,
                stepInherited: null,
                weight: null,
                weightInherited: null,
                price: null,
                priceInherited: null,
                priceWithTax: null,
                stock: null,
                availableQuantity: null
            }, window.productForm[this.keyForm])
    },
    mounted: function () {
        //INIT VAR
        updateSortableProducts();
        //METHOD
        this.updateProductForm();
        this.updateProductView();
    },
    methods: {
        getUnitReference: function () {
            if (this.productFamily.unit == 'g') {
                return 'kg';
            } else if (this.productFamily.unit == 'ml') {
                return 'L';
            } else {
                return this.productFamily.unit;
            }
        },
        updateProductForm: function () {
            this.changePriceWithTax();
            $('#productfamily_products_' + this.keyForm + '_unit').find('option').hide();
            log('fefe');
            switch (this.productFamily.unit) {
                case 'kg' :
                case 'g' :
                    $('.products-collection-table').find('th.step, td.step').show();
                    $('.products-collection-table').find('th.weight, td.weight').hide();
                    $('#productfamily_products_' + this.keyForm + '_unit').find('option[value="g"]').show();
                    $('#productfamily_products_' + this.keyForm + '_unit').find('option[value="kg"]').show();
                    break;
                case 'ml':
                case 'L' :
                    $('.products-collection-table').find('th.step, td.step').show();
                    $('.products-collection-table').find('th.weight, td.weight').hide();
                    $('#productfamily_products_' + this.keyForm + '_unit').find('option[value="ml"]').show();
                    $('#productfamily_products_' + this.keyForm + '_unit').find('option[value="L"]').show();
                    break;
                case 'piece':
                    $('.products-collection-table').find('th.step, td.step').hide();
                    $('.products-collection-table').find('th.weight, td.weight').show();
                    $('#productfamily_products_' + this.keyForm + '_unit').find('option[value="piece"]').show();
                    break;
            }
        },

        updateProductView: function () {

            //NE PAS SUPPRIMER
                /* for (i = 0; i < this.fieldToUpdate.length; i++) {
                            value = this[this.fieldToUpdate[i]];
                            inherited = this[this.fieldToUpdate[i]+'Inherited'];
                            inheritedValue = this['productFamily'][this.fieldToUpdate[i]];

                            if (value) {
                                this[this.fieldToUpdate[i]+'Inherited'] = false;
                                $('#product-item-' + this.keyForm).find('.'+this.fieldToUpdate[i]).html(value);
                            } else {
                                this[this.fieldToUpdate[i]+'Inherited'] = true;
                                $('#product-item-' + this.keyForm).find('.'+this.fieldToUpdate[i]).html('<span class="inherited">' + inheritedValue + '</span>');
                            }
                       }*/

            if (this.title) {
                this.titleInherited = false;
                $('#product-item-' + this.keyForm).find('.title').html(this.title);
            } else {
                this.titleInherited = true;
                $('#product-item-' + this.keyForm).find('.title').html('<span class="inherited">' + this.productFamily.title + '</span>');
            }

            if (this.unit) {
                this.unitInherited = false;
                $('#product-item-' + this.keyForm).find('.unit').html(this.unit);
            } else {
                this.unitInherited = true;
                $('#product-item-' + this.keyForm).find('.unit').html('<span class="inherited">' + this.productFamily.unit + '</span>');
            }

            if (this.step) {
                this.stepInherited = false;
                $('#product-item-' + this.keyForm).find('.step').html(this.step + ' / '+this.unit);
            } else {
                this.stepInherited = true;
                $('#product-item-' + this.keyForm).find('.step').html('<span class="inherited">' + this.productFamily.step + ' / '+ this.productFamily.unit+'</span>');
            }

            if (this.weight) {
                this.weightInherited = false;
                $('#product-item-' + this.keyForm).find('.weight').html(this.weight + ' / '+this.getUnitReference());
            } else {
                this.weightInherited = true;
                $('#product-item-' + this.keyForm).find('.weight').html('<span class="inherited">' + this.productFamily.weight + ' / '+this.getUnitReference()+'</span>');
            }

            if (this.price) {
                this.priceInherited = false;
                $('#product-item-' + this.keyForm).find('.price').html(this.price + ' € HT / '+this.getUnitReference());
            } else {
                this.priceInherited = true;
                $('#product-item-' + this.keyForm).find('.price').html('<span class="inherited">' + this.productFamily.price + ' € HT/ '+this.getUnitReference()+'</span>');
            }
            log(this.productFamily.behaviorCountStock);
            if (this.productFamily.behaviorCountStock == 'by-product-family') {
                $('.products-collection-table').find('.stock').hide();
            } else {
                $('.products-collection-table').find('.stock').show();
                $('#product-item-' + this.keyForm).find('.stock').html(this.availableQuantity + ' / '+this.getUnitReference());
            }
        },
        saveProductForm: function () {
            this.updateProductView();

            $('#form-product-modal-' + this.keyForm).modal('hide');

        },
    },
    watch: {
        titleInherited: function (val) {
            if(val)this.title = null;
        },
        unitInherited: function (val) {
            if(val)this.unit = null;
        },
        weightInherited: function (val) {
            if(val)this.weight = null;
        },
        stepInherited: function (val) {
            if(val)this.step = null;
        },
        priceInherited: function (val) {
            if(val)this.price = null;
        },
    }
});


appProductFamily = new Vue({
    el: '#lc-product-family-edit',
    delimiters: ['${', '}'],
    computed: {
        productFamily: function () {
            return {
                'title': this.title,
                'behaviorCountStock': this.behaviorCountStock,
                'unit': this.$refs.productUnitPrice.unit,
                'step': this.$refs.productUnitPrice.step,
                'weight': this.$refs.productUnitPrice.weight,
                'price': this.$refs.productUnitPrice.price,
                'taxRate': this.$refs.productUnitPrice.taxRate,
                'taxRateValue': this.$refs.productUnitPrice.taxRateValue
            };
        },
    },
    data() {

        return Object.assign(
            {
                indexFormProduct: 0,
                title: null,
                activeProducts: false,
                behaviorCountStock: null,
                formProductArray: [],
                currentSection: 'general',
                sectionsArray: [
                    {
                        name: 'general',
                        nameDisplay: 'Général'
                    },
                    {
                        name: 'price',
                        nameDisplay: 'Prix / stock'
                    },
                    {
                        name: 'products',
                        nameDisplay: 'Déclinaisons'
                    }
                ]
            }, window.appProductFamilyValues);
    },
    methods: {

        changeSection: function (section) {
            this.updateChild();
            this.currentSection = section.name;
        },
        addProductForm: function () {
            var $collectionHolder = $('tbody.products-collection');
            var prototype = $collectionHolder.data('prototype');
            var newForm = prototype;
            newForm = newForm.replace(/__name__/g, this.indexFormProduct);
            this.formProductArray.push(newForm);
            this.indexFormProduct++;
        },
        editProductForm: function (key) {
            $('#form-product-modal-' + key).modal();
            this.updateChild();
        },

        deleteProductForm: function (key) {
            this.formProductArray.splice(key, 1);
        },
        getUnitReference: function () {
            if (typeof this.$refs.productUnitPrice !== 'undefined') {
                return this.$refs.productUnitPrice.getUnitReference();
            }
        },
        updateChild: function () {
            if (typeof this.$refs.productForm !== 'undefined') {
                for (i = 0; i < this.$refs.productForm.length; i++) {
                    this.$refs.productForm[i].updateProductForm();
                    this.$refs.productForm[i].updateProductView();
                }
            }
        }
    },
    watch: {
        title: function () {
            this.updateChild()
        },
    }
});
